 /*
  * hashport.h 
  */
  
#ifndef PORTCOUNTER
typedef unsigned int ULONG;
typedef unsigned short USHORT;
#endif

struct pnode {
	unsigned short port; 
	unsigned int bytecount;
	unsigned int srccounter;
	unsigned int dstcounter;
        unsigned int flags;            /* hw flags */
        struct tags apptags;            /*struct for application flags -
                                          managed by patmatch*/
#ifdef	TCPPORTREPORT
	unsigned int syns;		/* tcp only */
	unsigned int fins;		/* tcp only */
	unsigned int rsts;		/* tcp only */
	unsigned int totalpkts;
#endif
	struct pnode *next;
};

/* was 1031 
*/
#define HSIZE 104729

struct plist{
	unsigned int entries;
	struct pnode *last;
	struct pnode *hashlist[HSIZE];
};

/**************************************************/
/* function prototypes */

struct pnode *
search_srcport(struct t_entry *te, struct plist *l, USHORT srcport, ULONG bytecount);

struct pnode *
search_dstport(struct t_entry *te, struct plist *l, USHORT dstport, ULONG bytecount, int tcpflag);

int insert_srcport(struct t_entry *te, struct plist *l, USHORT srcport, ULONG bytecount);
int insert_dstport(struct t_entry *te, struct plist *l, USHORT dstport, ULONG bytecount, int tcpflag);
void destroy_plist(struct plist *l);
void init_plist(struct plist *l);
void print_tcpplist(FILE *fd, struct plist *l, int tcpflag, int count);
void print_udpplist(FILE *fd, struct plist *l, int udpflag, int count);

