/*
 * store a string in a hashlist.  
 *
 * The stringlist structure must be supplied
 */

/*
 * storestring.h
*/
  
#ifndef STRINGSTORE
#define STRINGSTORE
struct ssnode {
	char *s;		/* malloc'ed space */
	int count;		/* times seen */
	unsigned int hash;     /* hash value of this string */
	struct ssnode *next;
};

#define HSIZE 104729

struct stringlist {
	unsigned int entries;
	struct ssnode *hashlist[HSIZE];
};

/**************************************************/
/* function prototypes */

/* stores the string if it has been seen before
 * else simply counts it
*/
char *
storeString(struct stringlist *sl, char *);

/*
 * print the set of strings out
*/
void
dumpString(struct stringlist *sl, FILE *fd, char *prefix);

/* init the hash structure, free any memory
*/
void
zeroString(struct stringlist *sl);

/* init the string structure - safe to
*  call before any use
*/
void
initString(struct stringlist *sl);
#endif
